#
# BETATRON high level library for platform and action arcade games.
# Copyright (C) 1997  Liouros Thanasis, liouros@hotmail.com
#
# PLKEYSAS.S: This file is part of the BETATRON library and can be used
#             and/or distributed only under the terms of the GNU Library
#             General Public License. See doc/readme.1st for details.
#




.data

# statiki metabliti kathorizei se poia katastasi brisketai to DFA tou handler



.equ   NORMAL	 , 0
.equ   PAUSE	 , 1
.equ   EXTENDED  , 2
.equ  CTRLPAUSE  , 3


.extern _pl_KeysPressed
.globl	_pl_int09handler
.globl	_pl_int09handler_end
.globl	_pl_int09handler_save_ds
.globl	_pl_keycondition

_pl_keycondition:
.byte 0

# edo sozetai o ds oste na fortothei apo ton handler gia kathe endexomeno
.text
_pl_int09handler_save_ds:
.word 0


_pl_int09handler:
	pushl %eax
	pushl %ebx
	pushl %ecx
	pushl %edx
	pushw %ds
	pushl %edi

   xor %ebx,%ebx
   movw %cs:_pl_int09handler_save_ds,%bx
   movw %bx,%ds

	inb	$0x060,%al	#   al o scan code   ah  status byte

	movb	_pl_keycondition,%cl

	cmpb	$NORMAL,%cl
	jne	L1
Lnormal:
# periptosi proti PAUSE
	cmpb	$0x0E1,%al	# elegkse an einai pause  arxizei me 225 teleionei me 197
	jne	Lnormal1
	movb	$PAUSE,_pl_keycondition    # pigaine se katastasi PAUSE
	jmp	fin
Lnormal1:
	cmpb	$0x0E0,%al	# elegkse gia tin periptosi extended code
	jne	Lnormal2
	movb	$EXTENDED,_pl_keycondition
	jmp	fin

Lnormal2:
	movb	%al,%bl # antigrafo ston bl
	movl	$_pl_KeysPressed,%edi

	testb	$128,%bl	#	  夘 breakcode
	jnz	breakcode	#	   ,㚘  @breakcode

makecode:			#	bl < 128
	movb	%bl,%cl
	andb	$7,%cl	#   cl:= makecode mod 8
	shrb	$3,%bl
	xorb	%bh,%bh #   bx:= makecode div 8
	movb	$1,%ch
	shlb	%cl,%ch #   maska ston ch


	orb	%ch,(%edi,%ebx)        # energopoiise to antistoixo bit
	jmp	fin



breakcode:
	andb	$127,%bl
	movb	%bl,%cl
	andb	$7,%cl	# cl:= makecode mod 8
	shrb	$3,%bl
	xorb	%bh,%bh # bx:= makecode div 8
	movb	$1,%ch
	shlb	%cl,%ch # maska ston ch
	notb	%ch
	andb	%ch,(%edi,%ebx)        # apenergopoiise to antistoixo bit
	jmp	fin


L1:			# elexei tin periptosi pause
	cmpb	$PAUSE,%cl
	jne	L2
	cmpb	$0x0c5,%al	       # einai to teleutaio byte tis akolouthias
	jne	fin		       # an oxi pida sto telos kai ase tin katastasi opos einai
	movb	$NORMAL,_pl_keycondition   # girna se normal katastasi
	jmp	fin

L2:				# elegxei tin periptosi extended code E0
	cmpb	$EXTENDED,%cl	# einai extended code
	jne	L3
	cmpb	$0x0f0,%al	# elegkse periptosi break code
	je	fin		# agnoise to break code ase tin katastasi opos einai
# elegxos gia tis periptoseis  Shift-PrintScreen kai Control - PrintScreen
	cmpb	$0x037,%al
	jne	L21    # an den einai epomenos elegxos
	movb	$NORMAL,_pl_keycondition
	jmp	fin
L21:
# elegxos gia tin periptosi CTRL-PAUSE
	cmpb	$0x46,%al
	jne	L22			  # an den einai epomenos elegxos
	movb	$CTRLPAUSE,_pl_keycondition
	jmp	fin
L22:
# elegxos gia periptosi  PRTSC
	cmpb	$0x2a,%al	# einai
	jne	L23
	movb	$NORMAL,_pl_keycondition
	jmp	fin
L23:
# elegxos merikon apo tis parapano periptoseis gia break codes
# periptoseis Ctrl-Prtsc, Prtsc, Shift-Prtsc
	cmpb	$0x0b7,%al
	jne	L24
	movb	$NORMAL,_pl_keycondition
	jmp	fin
L24:
# elegxos gia tis periptosis LSHift-(del,arrows,end,home,pgup,pgdn,ins,/)
	cmpb	$0x0AA,%al
	jne	L25
	movb	$NORMAL,_pl_keycondition
	jmp	fin
L25:
# elegxos gia tis periptosis RSHift-(del,arrows,end,home,pgup,pgdn,ins,/)
	cmpb	$0x0b6,%al
	jne	L26
	movb	$NORMAL,_pl_keycondition
	jmp	fin
L26:
# elegxos gia tis periptosis RSHift-(del,arrows,end,home,pgup,pgdn,ins,/)
# break code
	cmpb	$0x036,%al
	jne	L27
	movb	$NORMAL,_pl_keycondition
	jmp	fin
L27:
# einai aplo pliktro prepei na to epeksergastoume normally
	movb	$NORMAL,_pl_keycondition
	jmp	Lnormal2
#;;;

L3:
	cmpb	$CTRLPAUSE,%cl	# eimaste se katastasi CTRL-PAUSE
	jne	L4
	cmpb	$0x0c6,%al	# teleiose i akolouthia
	jne	fin		# an oxi	ase tin katastasi opos einai
	movb	$NORMAL,_pl_keycondition   # girna tin katastasi se normal
	jmp	fin
L4:


fin:
	movb	$0x020,%al
	outb	%al,$0x020	# 騠  

	popl %edi
	popw %ds
	popl %edx
	popl %ecx
	popl %ebx
	popl %eax
	sti
	iret

_pl_int09handler_end:

.END

